#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int t, n, m;
	cin >> t >> n >> m;
	vector<int> a(n);
	string s;
	int cn = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		if (a[i] % 2 == 1) {
			cn |= 2;
		}
		else {
			cn |= 1;
		}
	}
	cin >> s;
	if (cn == 3) {
		cout << "No";
		return 0;
	}
	cout << "Yes\n";
	if (t == 1) {
		return 0;
	}
	if (a[0] == a[1] && s[0] == s[1]) {
		cout << m << '\n';
		if (t == 3) {
			cout << "0\n";
		}
		return 0;
	}
	int cur_time = 0;
	while (a[0] != a[1]) {
		++cur_time;
		if (s[0] == 'L') {
			--a[0];
			if (a[0] == 1) {
				s[0] = 'R';
			}
		}
		else {
			++a[0];
			if (a[0] == m) {
				s[0] = 'L';
			}
		}
		if (s[1] == 'L') {
			--a[1];
			if (a[1] == 1) {
				s[1] = 'R';
			}
		}
		else {
			++a[1];
			if (a[1] == m) {
				s[1] = 'L';
			}
		}
	}
	cout << a[0] << '\n';
	if (t == 3) {
		cout << 1 << '\n';
		cout << cur_time << ' ' << a[0] << '\n';
	}
	return 0;
}
